// figura.h - Definicija klase geometrijskih figura (Figura).

#ifndef _figura_h_
#define _figura_h_

#include "tacka2.h"

class Figura {
  Tacka T;                                  // Teziste figure.
public:
  Figura (const Tacka &tt=ORG): T(tt)  {}   // Konstruktor.
  virtual ~Figura () {}                     // Destruktor.
  virtual Figura *kopija () const =0;       // Stvaranje kopije.
  Figura &postavi (Real xx, Real yy)        // Postavljanje figure.
    { T = Tacka (xx, yy); return *this; }
  Figura &pomeri (Real dx, Real dy)         // Pomeranje figure.
    { T = Tacka ( T.aps() + dx, T.ord() + dy); return *this; }
  virtual Real O () const =0 ;              // Obim.
  virtual Real P () const =0 ;              // Povrsina.
protected:
  virtual void citaj (istream &dd)       { dd >> T; }          // Citanje.
  virtual void pisi  (ostream &dd) const { dd << "T=" << T; }  // Pisanje.
  friend istream & operator>>(istream &dd, Figura &ff) //Uopsteno citanje
    { ff.citaj (dd); return dd; }                              //    i
  friend ostream & operator<<(ostream &dd, const Figura &ff)   // pisanje.
    { ff.pisi  (dd); return dd; }
} ;

#endif
