// greska.h - Klasa za greske (Greska).

#ifndef _greska_h_
#define _greska_h_

#include <iostream.h>
#include <string.h>

class Greska {
  char *poruka;
  void kopiraj (const char *p) {
    if (p) { poruka = new char [strlen(p)+1];
             strcpy (poruka, p);
    } else poruka = 0;
  }
  void brisi () { delete poruka; poruka = 0; }
public:
  Greska () { poruka = 0; }
  Greska (const char *por) { kopiraj (por); }
  Greska (const Greska &g) { kopiraj (g.poruka); }
  virtual ~Greska () { brisi (); }
  Greska & operator= (const Greska &g) {
    if (&g != this) { brisi (); kopiraj (g.poruka); }
    return *this;
  }
protected:
  virtual void pisi (ostream &d) const {
    d << "\n*** " << (poruka ? poruka : "Greska") << " ***\a\n";
  }
  friend ostream & operator<< (ostream &d, const Greska &g)
    { g.pisi (d); return d; }
  int imaPoruke () const { return poruka != 0; }
};

#endif
