// matem.C - Definicija metoda uz usluznu klasu Matem.

#include "matem.h"

double Matem::integral (const Fct &f, double a, double b) {
  const int MAX_INTERVAL = 30;
  try {
    return f.I(b) - f.I(a);
  } catch (GNemaIntegral g) {
    double dx = (b - a) / MAX_INTERVAL, s = 0;
    for (int i=0; i<MAX_INTERVAL; i++) s += f(a+i*dx);
    return s * dx;
  }
}

