// objekat.h - Definicija apstraktne klase objekata (Obj).

#ifndef _objekat_h_
#define _objekat_h_

#include <iostream.h>

class Obj {
  virtual int jednako (const Obj &obj) const =0;        // Da li su jednaki?
  virtual ostream &pisi  (ostream &d) const =0;         // Pisanje.
  virtual istream &citaj (istream &d) =0;               // Citanje.
public:
  virtual ~Obj () {}                                    // Unistavanje.
  virtual const char *klasa () const =0;                // Ime klase.
  virtual Obj *kopija () const =0;                      // Kopija objekta.
  friend int operator== (const Obj &o1, const Obj &o2)      // o1 == o2
    { return o1.klasa()==o2.klasa() ? o1.jednako(o2) : 0; }
  friend int operator!= (const Obj &o1, const Obj &o2)      // o1 != o2
    { return ! (o1 == o2); }
  friend ostream & operator<< (ostream &d, const Obj &obj)  // d  << obj
    { return obj.pisi (d); }
  friend istream & operator>> (istream &d, Obj &obj)        // d  >> obj
    { return obj.citaj (d); }
};

#endif
