// skup.C - Definicije funkcija uz klasu Skup.

#include "skup.h"

void Skup::dodaj (const Obj &obj) {        // Dodavanje objekta skupu.
	 Elem *novi = new Elem (obj.kopija());
         if (novi == 0) throw 1;
    posl = (posl ? posl->nar : prvi) = novi;
}

void Skup::kopiraj (const Skup &s) {       // Kopiranje skupa.
  prvi = posl = 0;
  for (Elem *tek=s.prvi; tek; tek=tek->nar) dodaj (*tek->obj);
}

void Skup::brisi   () {                                    // Unistavanje.
  while (prvi) { Elem *stari = prvi; prvi = prvi->nar; delete stari; }
  posl = 0;
}

Skup::Skup (const Obj &obj)                                // Konverzija.
  { if ((prvi = posl = new Elem (obj.kopija())) == 0) throw 1; }

int Skup::operator% (const Obj &obj) const {               // Element skupa.
  for (Elem *tek=prvi; tek; tek=tek->nar) if (*tek->obj == obj) return 1;
  return 0;
}

Skup operator+ (const Skup &s1, const Skup &s2) {          // Unija.
  Skup s (s1);
  for (Skup::Elem *tek=s2.prvi; tek; tek=tek->nar)
    if (! (s1 % *tek->obj)) s.dodaj (*tek->obj);
  return s;
}

Skup operator- (const Skup &s1, const Skup &s2) {          // Razlika.
  Skup s;
  for (Skup::Elem *tek=s1.prvi; tek; tek=tek->nar)
    if (! (s2 % *tek->obj)) s.dodaj (*tek->obj);
  return s;
}

Skup operator* (const Skup &s1, const Skup &s2) {          // Presek;
  Skup s;
  for (Skup::Elem *tek=s1.prvi; tek; tek=tek->nar)
    if (s2 % *tek->obj) s.dodaj (*tek->obj);
  return s;
}

ostream & operator<< (ostream &d, const Skup &s) {         // Pisanje.
  d << '{';
  for (Skup::Elem *tek=s.prvi; tek; tek=tek->nar) {
    d << *tek->obj << (tek->nar ? ", " : "");
  }
  return d << '}';
}
