// skup.h - Definicija klase skupa apstraktnih objekata (Skup).

#include "objekat.h"

class Skup {
  struct Elem {                                      // ELEMENT SKUPA
    Obj *obj;                                        // - sadrzaj
    Elem *nar;                                       // - naredni
    Elem (Obj *oo=0, Elem *nn=0) { obj=oo; nar=nn; } // Konstruktor.
    ~Elem () { delete obj; }                         // Destruktor.
  };

  Elem *prvi, *posl;                       // Elementi skupa.

  void dodaj   (const Obj &obj);           // Dodavanje objekta skupu.
  void kopiraj (const Skup &s);            // Kopiranje skupa.
  void brisi   ();                         // Unistavanje skupa.
public:
  Skup () { prvi = posl = 0; }                             // Prazan skup.
  Skup (const Obj &obj) ;                                  // Konverzija.
  Skup (const Skup &s) { kopiraj (s); }                    // Kopija.
  ~Skup () { brisi (); }                                   // Unistavanje.
  Skup & operator= (const Skup &s) {                       // Dodela.
    if (this != &s) { brisi (); kopiraj (s); }
    return *this;
  }
  int operator% (const Obj &obj) const;                    // Element skupa.
  friend Skup operator+ (const Skup &s1, const Skup &s2);  // Unija.
  friend Skup operator- (const Skup &s1, const Skup &s2);  // Razlika.
  friend Skup operator* (const Skup &s1, const Skup &s2);  // Presek.
  Skup & operator+= (const Skup &s) { return *this = *this + s; } // Unija.
  Skup & operator-= (const Skup &s) { return *this = *this - s; } // Razlika.
  Skup & operator*= (const Skup &s) { return *this = *this * s; } // Presek.
  friend ostream & operator<< (ostream &d, const Skup &s);  // Pisanje.
};