// tekst3.C - Definicije metoda uz klasu Tekst.

#include "tekst3.h"
#include <stdlib.h>

void Tekst::kopiraj (const char *n) {
  if ((niz = new char [strlen(n)+1]) == 0) exit (1);
  strcpy (niz, n);
}

Tekst & Tekst::operator= (const Tekst &t) {
  if (this != &t) { delete [] niz; kopiraj (t.niz); }
  return *this;
}

Tekst operator+ (const Tekst &t1, const Tekst &t2) {
  Tekst t; if ((t.niz = new char [+t1 + +t2 + 1]) == 0) exit (1);
  strcpy (t.niz, t1.niz); strcat (t.niz, t2.niz);
  return t;
}

char & Tekst::operator[] (int i) const {
  if (i<0 || +*this<=i) exit(2);
  return niz[i];
}

Tekst Tekst::operator() (int i, int j) const {
  if (i<0 || j<i || +*this<=j) exit(3);
  Tekst t; int d = j - i + 1;
  if ((t.niz = new char [d+1]) == 0) exit(1);
  strncpy (t.niz, this->niz+i, d);
  t.niz[d] = 0;
  return t;
}

int operator% (const Tekst &t1, const Tekst &t2){
  int d1 = +t1, d2 = +t2;
  for (int i=0; i<d1-d2+1; i++) {
    for (int j=0; j<d2; j++)
      if (t1.niz[i+j] != t2.niz[j]) break;
    if (j == d2) return i;
  }
  return -1;
}

istream & operator>> (istream &d, Tekst &t) {
  char *n; if ((n = new char [81]) == 0) exit (1);
  d >> n; t = n; delete [] n;
  return d;
}
