// tekst4.h - Definicija klase znakovnih nizova (Tekst).

#include "objekat.h"
#include <string.h>

class Tekst: public Obj {
  static const char ime[];                        // Ime klase.
  char *tks;                                      // Sadrzaj objekta.
  int jednako (const Obj &obj) const              // Da li su jednaki?
    { return strcmp (tks, ((Tekst &)obj).tks) == 0; }
  ostream &pisi  (ostream &d) const               // Pisanje.
    { return d << tks; }
  istream &citaj (istream &d) ;                   // Citanje.
  void pravi (const char *niz);                   // Stvaranje.
public:
  Tekst (const char *niz="") { pravi (niz); }     // Inicijalizacija nizom.
  Tekst (const Tekst &tt) { pravi (tt.tks); }     // Inicijalizacija tekstom.
  ~Tekst () { delete [] tks; }                    // Unistavanje.
  Tekst & operator= (const Tekst &t) {            // Dodela vrednosti.
    if (this != &t) { delete [] tks; pravi (t.tks); }
    return *this;
  }
  const char *klasa () const { return ime; }         // Ime klase.
  Obj *kopija () const                               // Kopija objekta.
    { Obj *oo = new Tekst (*this); if (oo == 0) throw 1; return oo; }
};
