// vekt.h - Definicija klase vektora realnih brojeva (Vekt).

#ifndef _vekt_h_
#define _vekt_h_

class Vekt {                            // Atributi:
  int min, max;                         //   granice indeksa,
  int duz;                              //   broj elemenata,
  double *niz;                          //   niz elemenata.
                                        // Pomocne metode:
  void pravi (int poc, int kra) ;       //   stvaranje vektora,
  void kopiraj (const Vekt &v) ;        //   kopiranje vektora,
  void brisi () ;                       //   unistavanje vektora.
  
public:
  enum Greska { OK,                     // Kodovi gresaka:
                OPSEG,                  //   neispravan opseg indeksa,
                MEMORIJA,               //   dodela memorije nije uspela,
                PRAZAN,                 //   vektor je prazan,
                INDEKS,                 //   indeks je izvan opsega,
                DUZINA } ;              //   neusaglasene duzine vektora.
                                        // Konstruktori:
  Vekt () { niz = 0; }                  //   prazan niz,
  Vekt (int kra) { pravi (1, kra); }    //   podrazumevani pocetni indeks,
  Vekt (int poc, int kra) {pravi(poc,kra);}//sa zadatim indeksima,
  Vekt (const Vekt &v) { kopiraj (v); } //   kopija vektora.
  ~Vekt () { brisi (); }                // Destruktor.
  Vekt & operator= (const Vekt &v) ;    // Dodela vrednosti.
  double & operator[] (int i) const ;   // Pristup elementu.
  friend double operator*(const Vekt &v,// Skalarni proizvod.
                          const Vekt &w) ;
  int minInd () const { return min; }   // Najmanji indeks.
  int maxInd () const { return max; }   // Najveci indeks.
} ;

#endif