// Kasa.java - Kasa samoposluge.

package kupovina;

class Kasa extends Thread {

  private Samoposluga samoposluga;
  private Red red;
  private int maxNaplata, idBroj;
  private boolean gotovo=false, radi=true;
  private static int ukBroj = 0;

  Kasa (Samoposluga samoposluga, int maxNaplata) {
    this.samoposluga = samoposluga;
    this.maxNaplata  = maxNaplata;
    red = new Red ();
    idBroj = ++ukBroj;
    start();
  }

  public void run () {
    System.out.println ("Kasa #" + idBroj + " samoposluge #" +
      samoposluga.dohvatiIdBroj() + " je spremna za rad");
    boolean prvi = true;
    while (true) {
      if (! radi) {
        if (! prvi)
          System.out.println ("Kasa #" + idBroj + " samoposluge #" + 
            samoposluga.dohvatiIdBroj() + " je zatvorena.");
        prvi = false;
        synchronized (this) { 
          while (! radi)
          try { wait (); } catch (InterruptedException e) {} 
        }
        if (! gotovo)
          System.out.println ("Kasa #" + idBroj + " samoposluge #" + 
            samoposluga.dohvatiIdBroj() + " je otvorena.");
      }
    if (gotovo) break;
      try {
        Kupac kupac = red.uzmi ();
        System.out.println ("Kupac #" + kupac.dohvatiIdBroj() + 
          " je stigao na kasu #" + idBroj + " samoposluge #" +
          samoposluga.dohvatiIdBroj());
        try { Thread.sleep ((long) (Math.random() * maxNaplata)); } 
          catch (InterruptedException e) {}
        kupac.naplaceno ();
      } catch (InterruptedException e) {}
    }
    System.out.println ("Kasa #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " je unistena.");
  }

  synchronized void zatvori () {      // Umesto suspend()
    radi = false;
    System.out.println ("Kasa #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " se zatvara.");
  }

  synchronized void otvori () {       // Umesto resume()
    if (! radi) { radi = true; notify (); }
    System.out.println ("Kasa #" + idBroj + " samoposluge #" +
      samoposluga.dohvatiIdBroj() + " se otvara.");
  }

  synchronized void zavrsi () {       // Umesto stop()
    gotovo = true;
    if (! radi) { radi = true; notify (); }
    this.interrupt ();
    System.out.println ("Kasa #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " se unistava.");
  }

  void staviURed (Kupac kupac) { red.stavi (kupac); }
  
  int dohvatiIdBroj () { return idBroj; }

}
