// Red.java - Red za cekanje kupaca.

package kupovina;

class Red {

  private static class Elem {

    Kupac kupac;
    Elem  sledeci;

    Elem (Kupac kupac) { this.kupac = kupac; }
    Elem (Kupac kupac, Elem sledeci) {
      this.kupac   = kupac;
      this.sledeci = sledeci;
    }
  }

  private Elem prvi, zadnji;
  private boolean odustani;
  private int idBroj;
  private static int ukBroj = 0;

  synchronized void stavi (Kupac kupac) {
    Elem novi = new Elem (kupac);
    if (prvi == null) prvi           = novi;
      else            zadnji.sledeci = novi;
    zadnji = novi;
    notify ();
  }

  synchronized Kupac uzmi () throws InterruptedException {
    while (prvi == null) wait ();
    Kupac kupac = prvi.kupac;
    prvi = prvi.sledeci; if (prvi == null) zadnji = null;
    return kupac;
  }

}