// Matr.java - Klasa realnih matrica.

package Matrica;

import Citaj;

public class Matr {

  double[][] mat;

  public Matr (int m, int n) { mat = new double[m][n]; }

  public Matr () { this (10, 10); };

  public int brojVrs () { return mat.length; }

  public int brojKol () { return mat[0].length; }

  private void proveriInd (int i, int j) throws EMatIndeks {
    if (i < 0 || i >= mat.length || j < 0 || j > mat[0].length)
      throw new EMatIndeks (i, j);
  }

  public void stavi (int i, int j, double b) throws EMatIndeks
    { proveriInd (i, j); mat[i][j] = b; }

  public double uzmi (int i, int j) throws EMatIndeks
    { proveriInd (i, j); return mat[i][j]; }

  private void proveriDim (Matr m2) throws EMatDimenzije {
    if (mat   .length != m2.mat   .length ||
        mat[0].length != m2.mat[0].length ) 
      throw new EMatDimenzije (this, m2);
  }

  public Matr kopija () {
    Matr m = new Matr (mat.length, mat[0].length);
    for (int i=0; i<mat.length; i++)
      for (int j=0; j<mat[0].length; j++)
        m.mat[i][j] = mat[i][j];
    return m;
  }

  public Matr dodaj (Matr m2) throws EMatDimenzije {
    proveriDim (m2);
    for (int i=0; i<mat.length; i++)
      for (int j=0; j<mat[0].length; j++)
        mat[i][j] += m2.mat[i][j];
    return this;
  }

  public static Matr zbir (Matr m1, Matr m2) throws EMatDimenzije {
    return m1.kopija (). dodaj (m2);
  }

  public static Matr proizvod (Matr m1, Matr m2) throws EMatDimenzije {
    if (m1.mat[0].length != m2.mat.length) throw new EMatDimenzije (m1, m2);
    Matr m = new Matr (m1.mat.length, m2.mat[0].length);
    for (int i=0; i<m1.mat.length; i++)
      for (int k=0; k<m2.mat[0].length; k++)
        for (int j=0; j<m2.mat.length; j++)
          m.mat[i][k] += m1.mat[i][j] * m2.mat[j][k];
    return m;
  }

  public Matr citaj () {
    System.out.print ("Vrs, kol? ");
    int vrs = Citaj.Int (), kol = Citaj.Int ();
    mat = new double [vrs][kol];
    for (int i=0; i<vrs; i++) {
      System.out.print ("Vrsta " + i + "? ");
      for (int j=0; j<kol; mat[i][j++]=Citaj.Double());
    }
    return this;
  }

  public String toString () {
    StringBuffer s = new StringBuffer ();
    for (int i=0; i<mat.length; i++){
      for (int j=0; j<mat[0].length; s.append(mat[i][j++]).append(' '));
      s.append('\n');
    }
    return s.toString ();
  }

}
