// ApstraktniNiz.java - Apstraktna zbirka celih brojeva u obliku niza.

package Zbirke;

public abstract class ApstraktniNiz implements Iterator {

  protected int[] niz; 
  protected int   duz, tek;

  public ApstraktniNiz (int kap) { niz = new int [kap]; duz = tek = 0; }

  public ApstraktniNiz () { this (10); }

  public void    naPrvi () { tek = 0; }

  public void    naSledeci () {
    if (tek++ == duz) System.exit (1);
  }

  public int     dohvatiTekuci () {
    if (tek == duz) System.exit (1);
    return niz[tek];
  }

  public void    izbaciTekuci () {
    if (tek == duz) System.exit (1);
    for (int i=tek; i<duz-1; i++) niz[i] = niz[i+1];
    duz--;
  }

  public void    izbaciSve () { duz = tek = 0; }

  public boolean kraj ()   { return tek == duz; }

  public boolean pun ()    { return duz == niz.length; }

  public boolean prazan () { return duz == 0; }

}
